## ftxui 5.0.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(ftxui
  LANGUAGES CXX
  VERSION 5.0.0
  DESCRIPTION "C++ Functional Terminal User Interface."
)

option(FTXUI_QUIET "Set to ON for FTXUI to be quiet" OFF)
option(FTXUI_BUILD_EXAMPLES "Set to ON to build examples" OFF)
option(FTXUI_BUILD_DOCS "Set to ON to build docs" OFF)
option(FTXUI_BUILD_TESTS "Set to ON to build tests" OFF)
option(FTXUI_BUILD_TESTS_FUZZER "Set to ON to enable fuzzing" OFF)
option(FTXUI_ENABLE_INSTALL "Generate the install target" ON)
option(FTXUI_CLANG_TIDY "Execute clang-tidy" OFF)
option(FTXUI_ENABLE_COVERAGE "Execute code coverage" OFF)
option(FTXUI_DEV_WARNINGS "Enable more compiler warnings and warnings as errors" OFF)

set(FTXUI_MICROSOFT_TERMINAL_FALLBACK_HELP_TEXT "On windows, assume the \
terminal used will be one of Microsoft and use a set of reasonnable fallback \
to counteract its implementations problems.")
if (WIN32)
  option(FTXUI_MICROSOFT_TERMINAL_FALLBACK
    ${FTXUI_MICROSOFT_TERMINAL_FALLBACK_HELP_TEXT} ON)
else()
  option(FTXUI_MICROSOFT_TERMINAL_FALLBACK
    ${FTXUI_MICROSOFT_TERMINAL_FALLBACK_HELP_TEXT} OFF)
endif()

include(cmake/ftxui_message.cmake)

add_library(screen
  include/ftxui/screen/box.hpp
  include/ftxui/screen/color.hpp
  include/ftxui/screen/color_info.hpp
  include/ftxui/screen/screen.hpp
  include/ftxui/screen/string.hpp
  src/ftxui/screen/box.cpp
  src/ftxui/screen/color.cpp
  src/ftxui/screen/color_info.cpp
  src/ftxui/screen/screen.cpp
  src/ftxui/screen/string.cpp
  src/ftxui/screen/terminal.cpp
  src/ftxui/screen/util.hpp
)

add_library(dom
  include/ftxui/dom/canvas.hpp
  include/ftxui/dom/direction.hpp
  include/ftxui/dom/elements.hpp
  include/ftxui/dom/flexbox_config.hpp
  include/ftxui/dom/node.hpp
  include/ftxui/dom/requirement.hpp
  include/ftxui/dom/take_any_args.hpp
  src/ftxui/dom/automerge.cpp
  src/ftxui/dom/blink.cpp
  src/ftxui/dom/bold.cpp
  src/ftxui/dom/hyperlink.cpp
  src/ftxui/dom/border.cpp
  src/ftxui/dom/box_helper.cpp
  src/ftxui/dom/box_helper.hpp
  src/ftxui/dom/canvas.cpp
  src/ftxui/dom/clear_under.cpp
  src/ftxui/dom/color.cpp
  src/ftxui/dom/composite_decorator.cpp
  src/ftxui/dom/dbox.cpp
  src/ftxui/dom/dim.cpp
  src/ftxui/dom/flex.cpp
  src/ftxui/dom/flexbox.cpp
  src/ftxui/dom/flexbox_config.cpp
  src/ftxui/dom/flexbox_helper.cpp
  src/ftxui/dom/flexbox_helper.hpp
  src/ftxui/dom/focus.cpp
  src/ftxui/dom/frame.cpp
  src/ftxui/dom/gauge.cpp
  src/ftxui/dom/graph.cpp
  src/ftxui/dom/gridbox.cpp
  src/ftxui/dom/hbox.cpp
  src/ftxui/dom/inverted.cpp
  src/ftxui/dom/linear_gradient.cpp
  src/ftxui/dom/node.cpp
  src/ftxui/dom/node_decorator.cpp
  src/ftxui/dom/paragraph.cpp
  src/ftxui/dom/reflect.cpp
  src/ftxui/dom/scroll_indicator.cpp
  src/ftxui/dom/separator.cpp
  src/ftxui/dom/size.cpp
  src/ftxui/dom/spinner.cpp
  src/ftxui/dom/strikethrough.cpp
  src/ftxui/dom/table.cpp
  src/ftxui/dom/text.cpp
  src/ftxui/dom/underlined.cpp
  src/ftxui/dom/underlined_double.cpp
  src/ftxui/dom/util.cpp
  src/ftxui/dom/vbox.cpp
)

add_library(component
  include/ftxui/component/animation.hpp
  include/ftxui/component/captured_mouse.hpp
  include/ftxui/component/component.hpp
  include/ftxui/component/component_base.hpp
  include/ftxui/component/component_options.hpp
  include/ftxui/component/event.hpp
  include/ftxui/component/loop.hpp
  include/ftxui/component/mouse.hpp
  include/ftxui/component/receiver.hpp
  include/ftxui/component/screen_interactive.hpp
  include/ftxui/component/task.hpp
  src/ftxui/component/animation.cpp
  src/ftxui/component/button.cpp
  src/ftxui/component/catch_event.cpp
  src/ftxui/component/checkbox.cpp
  src/ftxui/component/collapsible.cpp
  src/ftxui/component/component.cpp
  src/ftxui/component/component_options.cpp
  src/ftxui/component/container.cpp
  src/ftxui/component/dropdown.cpp
  src/ftxui/component/event.cpp
  src/ftxui/component/hoverable.cpp
  src/ftxui/component/input.cpp
  src/ftxui/component/loop.cpp
  src/ftxui/component/maybe.cpp
  src/ftxui/component/menu.cpp
  src/ftxui/component/modal.cpp
  src/ftxui/component/radiobox.cpp
  src/ftxui/component/radiobox.cpp
  src/ftxui/component/renderer.cpp
  src/ftxui/component/resizable_split.cpp
  src/ftxui/component/screen_interactive.cpp
  src/ftxui/component/slider.cpp
  src/ftxui/component/terminal_input_parser.cpp
  src/ftxui/component/terminal_input_parser.hpp
  src/ftxui/component/util.cpp
  src/ftxui/component/window.cpp
)

target_link_libraries(dom
  PUBLIC screen
)

target_link_libraries(component
  PUBLIC dom
)

if (NOT EMSCRIPTEN)
  find_package(Threads)
  target_link_libraries(component
    PUBLIC Threads::Threads
  )
endif()

include(cmake/ftxui_set_options.cmake)
ftxui_set_options(screen)
ftxui_set_options(dom)
ftxui_set_options(component)

include(cmake/ftxui_coverage.cmake)
ftxui_check_coverage(screen)
ftxui_check_coverage(dom)
ftxui_check_coverage(component)

include(cmake/ftxui_test.cmake)
include(cmake/ftxui_benchmark.cmake)
include(cmake/ftxui_fuzzer.cmake)
include(cmake/iwyu.cmake)
include(cmake/ftxui_export.cmake)
include(cmake/ftxui_install.cmake)
include(cmake/ftxui_package.cmake)

add_subdirectory(examples)
add_subdirectory(doc)

=== examples/CMakeLists.txt ===
if(NOT FTXUI_BUILD_EXAMPLES)
  return()
endif()

set(EXAMPLES_DIR ${CMAKE_CURRENT_SOURCE_DIR})
function(example name)
  add_executable(ftxui_example_${name} ${name}.cpp)
  target_link_libraries(ftxui_example_${name} PUBLIC ${DIRECTORY_LIB})
  file(RELATIVE_PATH dir ${EXAMPLES_DIR} ${CMAKE_CURRENT_SOURCE_DIR})
  set_property(GLOBAL APPEND PROPERTY FTXUI::EXAMPLES ${dir}/${name})
  target_compile_features(ftxui_example_${name} PRIVATE cxx_std_20)
endfunction(example)

add_subdirectory(component)
add_subdirectory(dom)

if (EMSCRIPTEN)
  string(APPEND CMAKE_EXE_LINKER_FLAGS " -s ALLOW_MEMORY_GROWTH=1")
  target_link_options(component PUBLIC "SHELL: -s ALLOW_MEMORY_GROWTH=1")

  get_property(EXAMPLES GLOBAL PROPERTY FTXUI::EXAMPLES)
  foreach(file
      "index.html"
      "sw.js"
      "run_webassembly.py")
    configure_file(${file} ${file})
  endforeach(file)
endif()

=== examples/component/CMakeLists.txt ===
set(DIRECTORY_LIB component)

example(button)
example(button_animated)
example(button_in_frame)
example(button_style)
example(canvas_animated)
example(checkbox)
example(checkbox_in_frame)
example(collapsible)
example(composition)
example(custom_loop)
example(dropdown)
example(flexbox_gallery)
example(focus)
example(focus_cursor)
example(gallery)
example(homescreen)
example(input)
example(input_style)
example(linear_gradient_gallery)
example(maybe)
example(menu)
example(menu2)
example(menu_entries)
example(menu_entries_animated)
example(menu_in_frame)
example(menu_multiple)
example(menu_style)
example(menu_underline_animated_gallery)
example(modal_dialog)
example(modal_dialog_custom)
example(nested_screen)
example(print_key_press)
example(radiobox)
example(radiobox_in_frame)
example(renderer)
example(resizable_split)
example(slider)
example(slider_direction)
example(slider_rgb)
example(tab_horizontal)
example(tab_vertical)
example(textarea)
example(toggle)
example(window)
example(with_restored_io)

=== examples/dom/CMakeLists.txt ===
set(DIRECTORY_LIB dom)

example(border)
example(border_colored)
example(border_style)
example(canvas)
example(color_gallery)
example(color_info_palette256)
example(color_truecolor_HSV)
example(color_truecolor_RGB)
example(dbox)
example(gauge)
example(gauge_direction)
example(graph)
example(gridbox)
example(hflow)
example(html_like)
example(linear_gradient)
example(package_manager)
example(paragraph)
example(separator)
example(separator_style)
example(size)
example(spinner)
example(style_blink)
example(style_bold)
example(style_color)
example(style_dim)
example(style_gallery)
example(style_hyperlink)
example(style_inverted)
example(style_strikethrough)
example(style_underlined)
example(style_underlined_double)
example(table)
example(vbox_hbox)
example(vflow)

=== debian/changelog ===
ftxui (5.0.0-2) unstable; urgency=medium

  [ Alex Myczko ]
  * Source only upload.
  * d/control: add myself as Uploaders to be able to do team upload.

 -- Alex Myczko <tar@debian.org>  Thu, 25 Apr 2024 07:49:39 +0200

ftxui (5.0.0-1) unstable; urgency=medium

  * Initial release. (Closes: #1062434)

 -- Shriram Ravindranathan <s20n@ters.dev>  Thu, 08 Feb 2024 13:21:29 +0000

=== debian/control ===
Source: ftxui
Section: devel
Priority: optional
Maintainer: Shriram Ravindranathan <s20n@ters.dev>
Uploaders: Alex Myczko <tar@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 iwyu,
 libgtest-dev,
 libbenchmark-dev,
Build-Depends-Indep:
 doxygen,
 graphviz,
Standards-Version: 4.6.2
Homepage: https://github.com/ArthurSonzogni/FTXUI
Vcs-Browser: https://salsa.debian.org/debian/ftxui
Vcs-Git: https://salsa.debian.org/debian/ftxui.git

Package: libftxui-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libftxui-component5.0.0 (= ${binary:Version}),
 libftxui-dom5.0.0 (= ${binary:Version}),
 libftxui-screen5.0.0 (= ${binary:Version}),
 ${misc:Depends},
Suggests: ftxui-doc
Description: Cross-platform C++ functional TUI library - Development Files
 ftxui is a modern C++ TUI library for building interfaces in a functional
 style.
 .
  - Functional style, Inspired by React
  - Simple and elegant syntax.
  - Keyboard & mouse navigation.
  - Support for UTF8 and fullwidth chars.
  - Support for animations.
  - Support for drawing.
  - No dependencies.
  - Cross platform: Linux, MacOS, WebAssembly, Windows
 .
 This package provides the development headers for ftxui.

Package: libftxui-component5.0.0
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 libftxui-dom5.0.0 (= ${binary:Version}),
 libftxui-screen5.0.0 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends},
Description: Cross-platform C++ functional TUI library - Component Module
 ftxui is a modern C++ TUI library for building interfaces in a functional
 style.
 .
  - Functional style, Inspired by React
  - Simple and elegant syntax.
  - Keyboard & mouse navigation.
  - Support for UTF8 and fullwidth chars.
  - Support for animations.
  - Support for drawing.
  - No dependencies.
  - Cross platform: Linux, MacOS, WebAssembly, Windows
 .
 This package provides the runtime library for the component module of ftxui.

Package: libftxui-dom5.0.0
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 libftxui-screen5.0.0 (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends},
Description: Cross-platform C++ functional TUI library - DOM Module
 ftxui is a modern C++ TUI library for building interfaces in a functional
 style.
 .
  - Functional style, Inspired by React
  - Simple and elegant syntax.
  - Keyboard & mouse navigation.
  - Support for UTF8 and fullwidth chars.
  - Support for animations.
  - Support for drawing.
  - No dependencies.
  - Cross platform: Linux, MacOS, WebAssembly, Windows
 .
 This package provides the runtime library for the DOM module of ftxui.

Package: libftxui-screen5.0.0
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Cross-platform C++ functional TUI library - Screen Module
 ftxui is a modern C++ TUI library for building interfaces in a functional
 style.
 .
  - Functional style, Inspired by React
  - Simple and elegant syntax.
  - Keyboard & mouse navigation.
  - Support for UTF8 and fullwidth chars.
  - Support for animations.
  - Support for drawing.
  - No dependencies.
  - Cross platform: Linux, MacOS, WebAssembly, Windows
 .
 This package provides the runtime library for the screen module of ftxui.

Package: ftxui-examples
Section: misc
Architecture: any
Depends:
 libftxui-component5.0.0 (= ${binary:Version}),
 libftxui-dom5.0.0 (= ${binary:Version}),
 libftxui-screen5.0.0 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Cross-platform C++ functional TUI library - Example Binaries
 ftxui is a modern C++ TUI library for building interfaces in a functional
 style.
 .
  - Functional style, Inspired by React
  - Simple and elegant syntax.
  - Keyboard & mouse navigation.
  - Support for UTF8 and fullwidth chars.
  - Support for animations.
  - Support for drawing.
  - No dependencies.
  - Cross platform: Linux, MacOS, WebAssembly, Windows
 .
 This package provides example binaries built with ftxui.

Package: ftxui-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
  ${misc:Depends},
Description: Cross-platform C++ functional TUI library - Documentation
 ftxui is a modern C++ TUI library for building interfaces in a functional
 style.
 .
  - Functional style, Inspired by React
  - Simple and elegant syntax.
  - Keyboard & mouse navigation.
  - Support for UTF8 and fullwidth chars.
  - Support for animations.
  - Support for drawing.
  - No dependencies.
  - Cross platform: Linux, MacOS, WebAssembly, Windows
 .
 This package includes the library reference and examples for ftxui.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE="Release" \
	-DFTXUI_ENABLE_INSTALL=ON \
	-DFTXUI_BUILD_EXAMPLES=ON \
	-DFTXUI_BUILD_DOCS=ON \
	-DBUILD_SHARED_LIBS=ON \
	-DCMAKE_CXX_INCLUDE_WHAT_YOU_USE="include-what-you-use;-Xiwyu;--cxx17ns;-Xiwyu;--mapping_file=$(CURDIR)/iwyu.imp;-Xiwyu;--no-default-mappings"

override_dh_auto_install:
	dh_auto_install --destdir debian/tmp

override_dh_installexamples:
	dh_installexamples -X CMakeLists.txt

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
    https://github.com/ArthurSonzogni/FTXUI/tags \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
